#! /usr/bin/perl -w


# Copyright (c) 2007 Takahiro Shinozaki

# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:

# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.

 
# Sat Dec 29 15:16:30 JST 2007
# Takahiro Shinozaki
 
if (@ARGV != 3 ) {
    die "proto2mono protomodel vFloor monophone-list";
}
 
open(PROTO, $ARGV[0]) || die "can not open $ARGV[0]";
open(VFL, $ARGV[1]) || die "can not open $ARGV[1]";
open(MONO, $ARGV[2]) || die "can not open $ARGV[2]";
 
@proto = <PROTO>;
 
# print global
foreach $row ( @proto ) {
    if ( $row =~ /~h/ ) {
        last;
    }
    $gldefrows++;
    print $row;
}
 
# print vFloors
while (<VFL>) {
    print $_;
}
 
# print each monophone
while (<MONO>) {
    if (/^$/ ) {
        next;
    }
    chomp;
    $phoneme = $_;
    for ($row =  $gldefrows;  $row < @proto ; $row++  ) {
        $out = $proto[$row];
        $out =~ s/~h \"proto\"/~h \"$phoneme\"/;
        print $out;
    }
}
